"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.increaseLcovConcat = exports.lcovConcat = void 0;
const dayjs_1 = __importDefault(require("dayjs"));
const concat_1 = require("../concat");
const parsers_1 = require("../parsers");
const readLcov_1 = require("../utils/readLcov");
const utils_1 = require("../utils");
function lcovConcat(lcovPath) {
    return __awaiter(this, void 0, void 0, function* () {
        const res = yield readLcov_1.getLcovFile(lcovPath);
        return new concat_1.LcovConcat().concat(...res).getRes();
    });
}
exports.lcovConcat = lcovConcat;
function increaseLcovConcat(lcovPath, opts) {
    return __awaiter(this, void 0, void 0, function* () {
        const res = yield readLcov_1.getLcovFile(lcovPath);
        const cwd = utils_1.getActualGitRepoRoot(opts.cwd);
        let { hash } = opts;
        if (!hash) {
            const subDate = dayjs_1.default(opts.since ? opts.since : new Date())
                .subtract(1, 'day')
                .format('YYYY-MM-DD');
            const logRes = yield new parsers_1.LogParser({
                repo: cwd,
                until: subDate,
            }).run();
            const [firstGitMessage] = logRes;
            hash = firstGitMessage.hash;
        }
        return (yield new concat_1.IncreaseConcat({
            cwd,
            hash,
        }).concat(...res)).getRes();
    });
}
exports.increaseLcovConcat = increaseLcovConcat;
