import { FileStreamOpt, StdoutStreamOpt } from '../../streams';
import { CommitInfo, FormatData, FullResult, GitRepoInfo, Lcov } from '../../types';
export interface Mapper {
    stdio: StdoutStreamOpt;
    file: FileStreamOpt;
}
export interface BaseProcessOpts<T extends keyof Mapper> {
    cwd?: string;
    output?: boolean;
    stream: {
        name?: T;
        opts?: T extends 'stdio' ? StdoutStreamOpt : FileStreamOpt;
    };
}
export declare abstract class BaseProcess<T extends keyof Mapper> {
    lcovPath: string[];
    opts: BaseProcessOpts<T>;
    protected lcov: Lcov;
    protected formatData: FormatData;
    abstract exec(): Promise<FullResult>;
    protected format(): void;
    protected output(data: unknown): void;
    protected getCreateInfo(): Promise<CommitInfo | null>;
    protected getGitRepoInfo(): GitRepoInfo;
}
export * from './full';
export * from './increase';
